module Dingtalk
  class << self
    attr_accessor :config
    def configure
      yield self.config ||= Config.new
    end

    def redis
      return nil if config.nil?
      @redis ||= config.redis
    end

    def key_expired
      return 100 if config.nil?
      config.key_expired || 100
    end

    def rest_client_options
      if config.nil?
        return {timeout: 5, open_timeout: 5, verify_ssl: true}
      end
      config.rest_client_options
    end
  end

  class Config
    attr_accessor :redis, :rest_client_options, :key_expired
  end
end