module Dingtalk
  module Token
    class RedisStore < Store

      def valid?
       redis.del(client.redis_key)
       super
      end

      def token_expired?
        redis.hvals(client.redis_key).empty?
      end

      def refresh_token
        super
        redis.hmset(
          client.redis_key, "access_token",
          client.access_token, "expired_at",
          client.expired_at
        )
        redis.expireat(client.redis_key, client.expired_at.to_i)
      end

      def access_token
        super
        client.access_token = redis.hget(client.redis_key, "access_token")
        client.expired_at   = redis.hget(client.redis_key, "expired_at")
        client.access_token
      end

      def redis
        Dingtalk.redis
      end
    end
  end

end